unit TG3D;

interface

uses Graph, Crt;

const
  Nz = 33;                           { ᫮ 祪  Z }
  Ny = 33;                           { ᫮ 祪  Y }
  NOfPoint = Ny * Nz;                { 饥 ᫮ 祪 }
  NOfPlane = (Ny-1) * (Nz-1) * 2;    { ᫮ ᪮⥩ }

type
  TLoc = record                      { 窠  ࠭⢥ }
    X, Y, Z: Real;
  end;
  PLocArr = ^TLocArr;
  TLocArr = array [1..NOfPoint] of TLoc;      { ᨢ 祪  ࠭⢥ }
  PScArr = ^TScArr;
  TScArr = array [1..NOfPoint] of PointType;  { ᨢ 祪  ࠭ }
  TPlane = record                             { ᪮  }
    P: array [1..3] of Word;         {   3 窨 }
    Color: Byte;                     {  ᪮      }
    Dist: Real;                      { ﭨ  ᪮ }
  end;
  PPlaneArr = ^TPlaneArr;
  TPlaneArr = array [1..NOfPlane] of TPlane;  { ᨢ ᪮⥩ }
  PRang = ^TRang;
  TRang = record    {    ஢ ᪮⥩  㤠 }
    Prev, Next: PRang;
    Val: Word;
  end;
  TEqu = record     { ࠢ ᪮  ࠭⢥ }
    A, B, C, D: Real;
  end;
  PPattArr = ^TPattArr;
  TPattArr = array [0..16] of FillPatternType; { ᪠ ᪮⥩ }

const
  GrToRad: Real = 3.1416/180;      { ॢ ࠤᮢ  ࠤ }
  GD: Integer = 3;                 { ᪨ ० }
  GM: Integer = 1;
  Look: TLoc = (X : 0; Y : 0; Z :-350);   {  ⥫ }
  Lite: TLoc = (X : 50; Y : 200; Z :-20); {  筨 ᢥ }

var
  Rang, OldRang: array [1..NOfPlane] of TRang; { ᨢ  ஢
                                ᪮⥩  ﭨ  ⥫ }
  First, Last: TRang;  {   ᫥   ᯨ᪥ ᪮⥩ }
  IniPoi: PLocArr;     { ⥫  ᨢ 砫 祪 }
  Plane: PPlaneArr;    { ⥫  ᨢ ᪮⥩ }
  Poi: PLocArr;        { ⥫  ᨢ ࠧ 祪 }
  ScPoi: PScArr;       { ⥫  ᨢ 祪  ࠭ }
  Angle: Integer;      {   孮 }
  Ch: Char;

procedure TakeMem;
procedure FormIniPoi;
procedure FormPl;
procedure InitSort;
procedure FormPoi (Angle, dX, dY, dZ: Integer);
procedure FormScPoi;
procedure CalcDist;
procedure SortPlan;
procedure SetColors;
procedure DrawPlan;
procedure PutMem;

implementation

{$I PATTERNS}     { ᨢ   ᪨ ᪮⥩ }

procedure FormPl; {  ᪮  窨 }
var
  i, j, k, n: Integer;
begin
  k := 1; n := 1;
  for j:=1 to Nz-1 do
  for i:=1 to Ny-1 do begin
    with Plane^[k] do begin
      P[1] := n + (n-1) div (Ny-1) + Ny;
      P[2] := n + (n-1) div (Ny-1);
      P[3] := n + (n-1) div (Ny-1) + 1;
    end;
    Inc (k);
    with Plane^[k] do begin
      P[1] := n + (n-1) div (Ny-1) + 1;
      P[2] := n + (n-1) div (Ny-1) + Ny;
      P[3] := n + (n-1) div (Ny-1) + Ny + 1;
    end;
    Inc (k); Inc (n);
  end;
end;

procedure FormIniPoi; { ନ㥬 ᨢ 砫 祪 }
var
  i, j, k: Integer;
  ForY, ForZ: Real;
begin
  k := 1;
  for j:=1 to Nz do
    for i:=1 to Ny do begin
      ForY := i - Ny div 2 - 1; { 頥 業 砫 न }
      ForZ := j - Nz div 2 - 1;
      with IniPoi^[k] do begin
        X := 25 * Sin (Sqrt (ForY*ForY + ForZ*ForZ) / 2.7);
                               { X - 㭪  Y  Z }
        Y := ForY * 250 / Ny;  { Y  Z -  न⭠ ⪠ }
        Z := ForZ * 250 / Nz;
      end;
      Inc (k);
    end;
end;

function PlanX ( X, Z: Real): Integer;
{ 뢠 X 祭  ७  ᪮ ࠭ }
begin
  PlanX := Round (Look.Z * X / (Look.Z - Z));
end;

function PlanY ( Y, Z: Real): Integer;
{ 뢠 Y 祭  ७  ᪮ ࠭ }
begin
  PlanY := Round (Look.Z * Y / (Look.Z - Z));
end;

procedure OnScreen ( X, Y: Integer; var ScrX, ScrY: Integer);
{ 뢠 न 窨  ࠭ }
begin
  ScrX := Y + 320;
  ScrY := 75 - Round (0.8 * X);
end;

procedure FormPoi (Angle, dX, dY, dZ: Integer);
{   ᬥ饭 砫쭮 ᨢ 祪 }
var
  i: Integer;
  RealA, CosA, SinA: Real;
begin
  RealA := Angle * GrToRad;
  CosA := Cos (RealA);
  SinA := Sin (RealA);
  for i:=1 to NOfPoint do
    with IniPoi^[i] do begin
      Poi^[i].X := X + dX;
      Poi^[i].Z := Z * CosA - Y * SinA + dZ;
      Poi^[i].Y := Z * SinA + Y * CosA + dY;
    end;
end;

procedure FormScPoi;
{ ନ㥬 ᨢ 祪  ࠭ }
var
  i: Integer;
begin
  for i:=1 to NOfPoint do
    with Poi^[i] do
      OnScreen ( PlanX (X, Z), PlanY (Y ,Z), ScPoi^[i].X, ScPoi^[i].Y);
end;

procedure CalcDist;
{ 뢠 ﭨ  ᪮  ⥫ }
var
  i, j: Integer;
  tX, tY, tZ: Real;
begin
  for i:=1 to NOfPlane do begin
    tX := 0; tY := 0; tZ := 0;
    for j:=1 to 3 do
      with Poi^[Plane^[i].P[j]] do begin
        tX := tX + X; tY := tY + Y; tZ := tZ + Z;
      end;
    tX := tX / 3; tY := tY / 3; tZ := tZ / 3;
    tZ := tZ - Look.Z;
    Plane^[i].Dist := tX*tX + tY*tY + tZ*tZ;
  end;
end;

procedure InitSort;
{ 樠 ᨢ  ஢ ᪮⥩ }
var i: Word;
begin
  First.Prev := NIL;
  First.Next := @Rang[1];
  Rang[1].Prev := @First;
  for i:=1 to NOfPlane-1 do begin
    Rang [i].Val := i;
    Rang [i].Next := @Rang [i+1];
    Rang [i+1].Prev := @Rang [i];
  end;
  Last.Next := NIL;
  Last.Prev := @Rang[NOfPlane];
  Rang [NOfPlane].Val := NOfPlane;
  Rang [NOfPlane].Next := @Last;
end;

procedure SortPlan;
{ ஢ ᪮⥩  ﭨ  ⥫ }
var
  i, j, k: Word;
  Val: Word;
  Test: PRang;
begin
  Move (Rang, OldRang, NOfPlane*SizeOf (TRang));
  Val := Last.Prev^.Val;
  First.Next := @Rang[Val];
  Rang[Val].Prev := @First;
  while OldRang[Val].Prev^.Prev <> NIL do begin
    Val := OldRang[Val].Prev^.Val;
    Test := First.Next;
    while (Test^.Next <> NIL) and
    (Plane^[Val].Dist > Plane^[Test^.Val].Dist) do Test := Test^.Next;
    Test^.Prev^.Next := @Rang [Val];
    Rang[Val].Prev := Test^.Prev;
    Rang[Val].Next := Test;
    Test^.Prev := @Rang [Val];
  end;
end;

procedure DrawPlan;
{ 㥬 ᪮  浪 ਡ  ⥫ }
var
  i, j: Integer;
  P: array [1..3] of PointType;
  Val: Word;
begin
  Val := Last.Prev^.Val;
  repeat
    for j:=1 to 3 do P[j] := ScPoi^[Plane^[Val].P[j]];
    SetFillPattern (PPattArr (@Pattern)^[Plane^[Val].Color], 15);
    FillPoly (3, P);
    if Rang[Val].Prev^.Prev = NIL then Exit;
    Val := Rang[Val].Prev^.Val;
  until FALSE;
end;

procedure GetNormVect (Equ: TEqu; var Loc: TLoc);
{ ।塞 ଠ  ᪮ }
begin
  with Loc, Equ do begin
    X := A; Y := B; Z := C;
  end;
end;

procedure GetLiteVect (Plane: TPlane; var Loc: TLoc);
{ ।塞  ᢥ }
begin
  with Loc do begin
    X := Poi^[Plane.P[1]].X - Lite.X;
    Y := Poi^[Plane.P[1]].Y - Lite.Y;
    Z := Poi^[Plane.P[1]].Z - Lite.Z;
  end;
end;

function GetCosA (a, b: TLoc): Real;
{ ।塞 㣮  ᢥ  ᪮ }
var
  Moda, Modb: Real;
begin
  with a do Moda := Sqrt (X*X+Y*Y+Z*Z);
  with b do Modb := Sqrt (X*X+Y*Y+Z*Z);
  GetCosA := (a.X*b.X+a.Y*b.Y+a.Z*b.Z)/(Moda*Modb);
end;

function GetColor (CosA: Real; Sign: Integer): Byte;
{ ।塞 梥 ᪮ }
begin
  if CosA < 0 then CosA := -CosA;
  if Sign = 0 then GetColor := Round (8 - CosA * 8)
  else GetColor := Round (8 + CosA * 8);
end;

procedure GetEqu (var Equ: TEqu; Plane: TPlane);
{ ।塞 ࠢ ᪮ }
var
  e: array [1..6] of Real;
begin
  with Equ, Poi^[Plane.P[1]] do begin
    e[1] := Poi^[Plane.P[2]].X - X;
    e[2] := Poi^[Plane.P[2]].Y - Y;
    e[3] := Poi^[Plane.P[2]].Z - Z;
    e[4] := Poi^[Plane.P[3]].X - X;
    e[5] := Poi^[Plane.P[3]].Y - Y;
    e[6] := Poi^[Plane.P[3]].Z - Z;
    A := e[2]*e[6] - e[3]*e[5];
    B := e[3]*e[4] - e[1]*e[6];
    C := e[1]*e[5] - e[2]*e[4];
    D := - A*X - B*Y - C*Z;
  end;
end;

function GetSign (var Equ: TEqu; Loc: TLoc): Integer;
{ ।塞 ࠭⢮ }
var
  n: Real;
begin
  with Loc, Equ do n := A*X + B*Y + C*Z + D;
  if n > 0 then
    GetSign := 1
  else
    GetSign := -1;
end;

procedure SetColors;
{ ⠢塞 梥 ᪮⥩ }
var
  i: Integer;
  Equ: TEqu;
  NormVect, LiteVect: TLoc;
  Sign: Integer;
begin
  for i:=1 to NOfPlane do begin
    GetEqu (Equ, Plane^[i]);
    GetNormVect (Equ, NormVect);
    GetLiteVect (Plane^[i], LiteVect);
    Sign := GetSign (Equ, Lite) - GetSign (Equ, Look);
    Plane^[i].Color :=
    GetColor (GetCosA (NormVect, LiteVect), Sign);
  end;
end;

procedure TakeMem;
{ ࢨ㥬  }
begin
  GetMem (IniPoi, SizeOf (TLocArr));
  GetMem (Plane, SizeOf (TPlaneArr));
  GetMem (Poi, SizeOf (TLocArr));
  GetMem (ScPoi, SizeOf (TScArr));
end;

procedure PutMem;
{ ᢮  }
begin
  FreeMem (IniPoi, SizeOf (TLocArr));
  FreeMem (Plane, SizeOf (TPlaneArr));
  FreeMem (Poi, SizeOf (TLocArr));
  FreeMem (ScPoi, SizeOf (TScArr));
end;

begin
end.